<?php

namespace Radar\Users;

/**
 * Description of NumbersParserUser
 *
 * @author Zelepukin
 */
class NumbersParserUser implements UserInterface
{

    use UserTrait;

    private $db;
    private $userDataTableName;

    public function __construct(\Radar\DataBase\DataBase $db, $userDataTableName)
    {
        $this->db = $db;
        $this->userDataTableName = $userDataTableName;
    }

    public function login($user)
    {
        $_SESSION['user'] = $this->getDataByLogin($user);
    }

    public function checkLogin(\Psr\Http\Message\ServerRequestInterface $request)
    {
        if ($this->isLogged()) {
            return true;
        }

        $login = $request->getParsedBody()['login'];
        $password = $request->getParsedBody()['password'];

        if (!empty($login) && !empty($password)) {
            if ($this->checkUserData(['login' => $login, 'password' => $password])) {
                $this->login($login);

                return true;
            }
        }

        return false;
    }

    public function getLogin()
    {
        if (!$this->isLogged()) {
            return false;
        }

        return $_SESSION['user']['login'];
    }

    public function isLogged()
    {
        return (!empty($_SESSION['user']));
    }

    public function getData()
    {
        if (!$this->isLogged()) {
            return false;
        }

        return $_SESSION['user'];
    }

    public function getDataByLogin($login)
    {
        $condition = " `login` = {$this->db->dbh->quote($login)}";

        $userData = $this->db->select(['*'], [$this->userDataTableName], $condition);

        return $userData;
    }

    public function isTestUser()
    {
        return $_SESSION['user']['test'] === '1' ? true : false;
    }

    
    public function isLoggedThroughLink()
    {
        return false;
    }

}
