$(function () {
    $('#number-search-button').click(function () {
        var phoneNumber = $('#number-for-search').val();

        $.ajax({
            url: 'search-by-number',
            dataType: 'json',
            method: 'POST',
            data: {
                phoneNumber: phoneNumber
            },
            success: function (data) {
                var $numberInfoBlock = $('.number-info');
                var $numberErrorBlock = $('.number-error');

                $numberErrorBlock.addClass('invisible').children('.number-error-text');
                $numberInfoBlock.addClass('invisible');

                if (data.error) {
                    $('.number-error').removeClass('invisible').find('.number-error-text').text(data.error);
                } else if (data.operator && data.region) {
                    var operatorInfo = data.operator;
                    var regionInfo = data.region;

                    $numberInfoBlock.removeClass('invisible').find('.region-name').text(regionInfo);
                    $numberInfoBlock.find('.operator-name').text(operatorInfo);
                }
            }
        });
    });

    $('#send-info-via-email').click(function () {
        var $button = $(this);
        sendEmailRequest('send-info-via-email',$button,'main');
    });

    new Dropzone("#numbers-upload-form", {
        paramName: "file", // The name that will be used to transfer the file
        uploadMultiple: false,
        maxFiles: 1,
        addRemoveLinks: 'Test',
        dictDefaultMessage: '',
        dictRemoveFile: 'Удалить файл',
        dictInvalidFileType: ' Только файлы формата .csv !',
        dictFileTooBig: ' Размер файла слишком большой, ограничение - 40 Мбайт !',
        dictMaxFilesExceeded: ' Только один файл за раз !',
        maxFilesize: 40, // MB
        acceptedFiles: '.csv',
        accept: function (file, done) {
            done();
        },
        init: function () {
            var dropzone = this;
            var maxQueuedFilesCount = dropzone.options.maxFiles;

            dropzone.on('error', function (file, errorMessage, xhr) {
                var $currentFilePreview = $(file.previewElement);
                var timerCount = 3000;

                $currentFilePreview.find('.dz-error-message').show();
                $('.btn-upload').attr('disabled', true);

                setTimeout(function () {
                    $(file.previewElement).find('.dz-error-message').hide('slow');
                    $('.btn-upload').attr('disabled', false);
                    if (dropzone.files.length > maxQueuedFilesCount) {
                        dropzone.removeFile(file);
                    }
                }, timerCount);

                runTimer($currentFilePreview.find('.dz-error-message > span'), 'Файл будет удален через %s секунд', timerCount);

                console.log(file + 'error occured !');
                console.log(errorMessage + ' !');
                console.log(xhr);
            }).on('addedfile', function (file) {
                console.log(file);
                $('.btn-upload').attr('disabled', false);
                hideUploadedFilePlaceholder($('.dz-file-preview-placeholder'), $('.dz-message'), $('#numbers-upload-form'));
            }).on('removedfile', function (file) {
                if (dropzone.files.length === 0) {
                    hideUploadedFilePlaceholder($('.dz-file-preview-placeholder'), $('.dz-message'), $('#numbers-upload-form'));
                }
            }).on('success', function (file, xhr) {
                dropzone.removeAllFiles();

                showUploadedFilePlaceholder($('.dz-file-preview-placeholder'), $('.dz-message'), $('#numbers-upload-form'));

                var downloadLink = JSON.parse(xhr).createdFileUrl;
                $('.download-link').attr('href', downloadLink);
                $('.btn-clear').attr('disabled', false);

            });

            $('.btn-clear').click(function () {
                dropzone.removeAllFiles();
                $('.btn-upload').attr('disabled', true);
                hideUploadedFilePlaceholder($('.dz-file-preview-placeholder'), $('.dz-message'), $('#numbers-upload-form'));
            });

            $('.btn-upload').click(function () {
                dropzone.processQueue();
                $('.btn-upload,.btn-clear').attr('disabled', true);
            });
        },
        previewTemplate: '<div class="dz-preview dz-file-preview">' +
                '<div class="dz-details">' +
                '<img class="csv-thumbnail" src="img/thumbnails/csv_thumb.png" />' +
                '<div class="dz-filename"><span data-dz-name></span></div>' +
                '<div class="dz-size" data-dz-size></div>' +
                '</div>' +
                '<div class="dz-progress"><span class="dz-upload" data-dz-uploadprogress></span></div>' +
                '<div class="dz-success-mark"><span class="badge btn-success"> Загружено </span></div>' +
                '<div class="dz-error-mark"><span class="badge btn-danger"> Ошибка </span></div>' +
                '<div class="dz-error-message"><span data-dz-errormessage></span></div>' +
                '</div>',
        autoProcessQueue: false,
        createImageThumbnails: true,
        thumbnailWidth: 30,
        thumbnailHeight: 50
    });
});



