/**
 * 
 * @returns {Boolean}
 */
function toggleUploadedFilePlaceholder() {
    var $placeholder = $('.dz-file-preview-placeholder');
    var $message = $('.dz-message');
    var $uploadForm = $('#numbers-upload-form');

    if ($placeholder.is(':visible')) {
        hideUploadedFilePlaceholder($placeholder, $message, $uploadForm);
    } else {
        showUploadedFilePlaceholder($placeholder, $message, $uploadForm);
    }

    return true;
}

/**
 * 
 * @param {JQuery Obj} $placeholder
 * @param {JQuery Obj} $message
 * @param {JQuery Obj} $uploadForm
 * @returns {Boolean} true
 */
function showUploadedFilePlaceholder($placeholder, $message, $uploadForm) {
    $placeholder.show();
    $message.hide().addClass('with-placeholder').removeClass('with-file-info');
    $uploadForm.addClass('with-placeholder');

    return true;
}

/**
 * 
 * @param {JQuery Obj} $placeholder
 * @param {JQuery Obj} $message
 * @param {JQuery Obj} $uploadForm
 * @returns {Boolean} true
 */
function hideUploadedFilePlaceholder($placeholder, $message, $uploadForm) {
    $placeholder.hide();
    $message.show().removeClass('with-placeholder');
    $uploadForm.removeClass('with-placeholder');

    if ($('.dz-preview.dz-file-preview').length > 0) {
        $message.addClass('with-file-info');
    }
//  Подождем пока из dom'a удалится блок с инфой файла
    setTimeout(function () {
        if ($('.dz-preview.dz-file-preview').length === 0) {
            $message.removeClass('with-file-info');
        }
    }, 1000);

    return true;
}

/**
 * Отображает таймер обратного отсчета в теле переданного элемента
 * @param {Jquery Obj} $element
 * @param {String} userText
 * @param {Integer} time
 * @param {Integer} defaultTimeout
 * @returns {Boolean}
 */
function runTimer($element, userText, time, defaultTimeout) {
    var $timerElement = $element;
    var originalText = $timerElement.text();
    var timerText = userText;
    var timeout = typeof defaultTimeout !== 'undefined' ? defaultTimeout : 100;
    var countdownTime = typeof time !== 'undefined' ? time : 1000;

    var intervalId = setInterval(function () {
        countdownTime -= timeout;
        var seconds = Math.ceil10(countdownTime / 1000, -1);
        var text = timerText.replace('%s', seconds);
        $element.text(originalText + " \n " + text);

        if (countdownTime <= 0) {
            clearInterval(intervalId);
        }
    }, timeout);

    return true;
}

function showError($errorElem, $connectedButtonElem, errorText) {
    $errorElem.css({'display': 'inline-block'}).children('.error-text').text(errorText);
    $connectedButtonElem.attr('disabled', true);

    return true;
}

function hideError($errorElem, $connectedButtonElem) {
    $errorElem.hide('slow');
    $connectedButtonElem.attr('disabled', false);

    return true;
}

/**
 * 
 * @param {type} url
 * @param {type} $button
 * @param {type} from
 * @returns {Boolean}
 */
function sendEmailRequest(url,$button,from) {
    $.ajax({
        url: url,
        dataType: 'json',
        method: 'POST',
        data: {
            from: from
        },
        success: function (data) {
            console.log(data);
            if (data.message === '2') {
                $button.removeClass('btn-warning')
                        .addClass('btn-success')
                        .text('Сообщение отправлено');
            } else {
                $button.removeClass('btn-warning')
                        .addClass('btn-danger')
                        .text('Отправить не получилось :(');
            }

            setTimeout(function () {
                $button.removeClass('btn-success btn-danger')
                        .addClass('btn-warning')
                        .text('Отправить повторно');
            }, 3000);
        }
    });
    
    return true
}

(function () {
    /**
     * Корректировка округления десятичных дробей.
     *
     * @param {String}  type  Тип корректировки.
     * @param {Number}  value Число.
     * @param {Integer} exp   Показатель степени (десятичный логарифм основания корректировки).
     * @returns {Number} Скорректированное значение.
     */
    function decimalAdjust(type, value, exp) {
        // Если степень не определена, либо равна нулю...
        if (typeof exp === 'undefined' || +exp === 0) {
            return Math[type](value);
        }
        value = +value;
        exp = +exp;
        // Если значение не является числом, либо степень не является целым числом...
        if (isNaN(value) || !(typeof exp === 'number' && exp % 1 === 0)) {
            return NaN;
        }
        // Сдвиг разрядов
        value = value.toString().split('e');
        value = Math[type](+(value[0] + 'e' + (value[1] ? (+value[1] - exp) : -exp)));
        // Обратный сдвиг
        value = value.toString().split('e');
        return +(value[0] + 'e' + (value[1] ? (+value[1] + exp) : exp));
    }

    // Десятичное округление к ближайшему
    if (!Math.round10) {
        Math.round10 = function (value, exp) {
            return decimalAdjust('round', value, exp);
        };
    }
    // Десятичное округление вниз
    if (!Math.floor10) {
        Math.floor10 = function (value, exp) {
            return decimalAdjust('floor', value, exp);
        };
    }
    // Десятичное округление вверх
    if (!Math.ceil10) {
        Math.ceil10 = function (value, exp) {
            return decimalAdjust('ceil', value, exp);
        };
    }
})();

